# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## 0.7.0
### Added
- `PayloadRef::set_props` for setting payload properties in a non-alloc way.

### Changed
- Rename `Payload::properties()` to a shorter `Payload::props()`.
- Rename templates to constraints. This affects `Constraint` and `ConstraintRef` types and better describes their purpose.

### Fixed
- Encoding Image4 payload now includes the payload properties.

## 0.6.0
### Added
- Support for banning specific tags in manifest templates.
- `body()` methods on manifests.
- `CertRef` type to represent a single certificate and certificate chain iterators.
- `Manifest` and `ManifestRef` now have `resign()` methods.

### Changed
- Signing manifests is now generic. There is no longer a dependency on RSA and any particular digest algorithms.

### Fixed
- `Template::match_value` wasn't working properly.

## 0.5.0
### Added
- Support for signing Image4 manifests.
- `AsRef<UnsignedManifest*>` implementations for signed manifest types.
- Added `AnyManifestRef` and `AnyManifest` types to represent either a signed or an unsigned manifest.
- Added support for `no_alloc` decoding of properties.

### Fixed
- Broken use scopes in `util` module could cause warning during builds.

## 0.4.0
### Added
- Support for property templates found in extensions of X.509 certificates used to sign manifests.
- `Template` now implements `From<Value>`.
- `UnsignedManifestRef` and `UnsignedManifest` types to support unsigned manifests.

### Changed
- Serializing a `Value` through Serde will use untagged representation.
- `DictRef` and `Dict` now contain the whole encoding of the sequence and expose it using their `as_bytes()` methods.

## 0.3.0
### Added
- Support (de)serialization of `Value` and `Tag` using `serde`.
- `new` methods for `Image` and `ImageRef`.
- Proper fields for the `ComprInfo` structure (thanks to xerub's [img4lib](https://github.com/xerub/img4lib) and S).

### Changed
- Add a feature to enable the `property` module.
- Setters on `PayloadRef` and `Payload` no longer panic.
- The compression algorithm is taken from the payload's compression info instead of being detected using its signature.

### Fixed
- Library crate docs now mention `serde` and `property` features.

## 0.2.0
### Added
- Feature gates on specific Image4 format parts.
- Implement FromStr on Tag.
- Expose constructors on Payload and PayloadRef.
- Provide access to keybags and compression info on Payload and PayloadRef.
- Allow to construct ImageRef and Image from payloads.
- CertChainRef and CertChain wrappers for encoded certificate chains.

### Changed
- A manifest's certificate chain is no longer decoded when the manifest is decoded.
- Conversion between Manifest and ManifestRef can now be done in both ways.
- Add alloc feature to support environments without a dynamic allocator.
- Removed `DictRef::header()` and `Dict::header()`.

## 0.1.0
- Initial release.