//! Contains the [`ManifestRef`], [`Manifest`] types that both represent a signed Image4 manifest,
//! their unsigned counterparts and supporting types.

mod borrowed;
mod cert_chain;
#[cfg(feature = "signature")]
mod error;
#[cfg(any(feature = "alloc", test))]
mod owned;

pub use borrowed::{AnyManifestRef, ManifestRef, UnsignedManifestRef};
pub use cert_chain::{CertChainRef, CertRef};
#[cfg(feature = "signature")]
pub use error::SigningError;
#[cfg(any(feature = "alloc", test))]
pub use {
    cert_chain::{Cert, CertChain},
    owned::{AnyManifest, Manifest, UnsignedManifest},
};
