//! An **EXPERIMENTAL** crate containing an implementation of signing and verification primitives
//! usable with the [`image4`](https://crates.io/crates/image4) crate.

#![warn(missing_docs)]
#![warn(missing_debug_implementations)]
#![warn(rust_2018_idioms)]

mod algo;
pub mod error;
mod keys;
mod sig;

pub use algo::{DigestAlgo, SigningAlgo};
pub use keys::{PrivateKey, PublicKey, SigningKey, VerifyingKey};
pub use sig::Signature;
