//! Provides [`ComprInfo`] structure and compression algorithm identifier constants.

use der::Sequence;

/// An algorithm identifier for LZFSE.
pub const COMPR_ALGO_LZFSE: u32 = 1;

/// Compression info structure from iOS 10 that may be present in Image4 payloads.
#[derive(Clone, Eq, PartialEq, Hash, Debug, Sequence)]
pub struct ComprInfo {
    /// Algorithm identifier. Currently only [`COMPR_ALGO_LZFSE`] is known.
    pub algo: u32,
    /// Size of the uncompressed payload contents.
    pub uncompressed_size: u32,
}
